/**
 * Autogenerated by Thrift Compiler (0.17.0)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package org.example.com.baeldung.thrift.impl;

import javax.annotation.processing.Generated;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked", "unused"})
@Generated(value = "Autogenerated by Thrift Compiler (0.17.0)", date = "2022-12-17")
public class saveWork implements org.apache.thrift.TBase<saveWork, saveWork._Fields>, java.io.Serializable, Cloneable, Comparable<saveWork> {
  private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("saveWork");

  private static final org.apache.thrift.protocol.TField WORKER_COUNT_FIELD_DESC = new org.apache.thrift.protocol.TField("workerCount", org.apache.thrift.protocol.TType.I32, (short)1);

  private static final org.apache.thrift.scheme.SchemeFactory STANDARD_SCHEME_FACTORY = new saveWorkStandardSchemeFactory();
  private static final org.apache.thrift.scheme.SchemeFactory TUPLE_SCHEME_FACTORY = new saveWorkTupleSchemeFactory();

  public int workerCount; // required

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements org.apache.thrift.TFieldIdEnum {
    WORKER_COUNT((short)1, "workerCount");

    private static final java.util.Map<java.lang.String, _Fields> byName = new java.util.HashMap<java.lang.String, _Fields>();

    static {
      for (_Fields field : java.util.EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // WORKER_COUNT
          return WORKER_COUNT;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new java.lang.IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByName(java.lang.String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final java.lang.String _fieldName;

    _Fields(short thriftId, java.lang.String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    @Override
    public short getThriftFieldId() {
      return _thriftId;
    }

    @Override
    public java.lang.String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __WORKERCOUNT_ISSET_ID = 0;
  private byte __isset_bitfield = 0;
  public static final java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
  static {
    java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new java.util.EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.WORKER_COUNT, new org.apache.thrift.meta_data.FieldMetaData("workerCount", org.apache.thrift.TFieldRequirementType.DEFAULT, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I32)));
    metaDataMap = java.util.Collections.unmodifiableMap(tmpMap);
    org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(saveWork.class, metaDataMap);
  }

  public saveWork() {
  }

  public saveWork(
    int workerCount)
  {
    this();
    this.workerCount = workerCount;
    setWorkerCountIsSet(true);
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public saveWork(saveWork other) {
    __isset_bitfield = other.__isset_bitfield;
    this.workerCount = other.workerCount;
  }

  @Override
  public saveWork deepCopy() {
    return new saveWork(this);
  }

  @Override
  public void clear() {
    setWorkerCountIsSet(false);
    this.workerCount = 0;
  }

  public int getWorkerCount() {
    return this.workerCount;
  }

  public saveWork setWorkerCount(int workerCount) {
    this.workerCount = workerCount;
    setWorkerCountIsSet(true);
    return this;
  }

  public void unsetWorkerCount() {
    __isset_bitfield = org.apache.thrift.EncodingUtils.clearBit(__isset_bitfield, __WORKERCOUNT_ISSET_ID);
  }

  /** Returns true if field workerCount is set (has been assigned a value) and false otherwise */
  public boolean isSetWorkerCount() {
    return org.apache.thrift.EncodingUtils.testBit(__isset_bitfield, __WORKERCOUNT_ISSET_ID);
  }

  public void setWorkerCountIsSet(boolean value) {
    __isset_bitfield = org.apache.thrift.EncodingUtils.setBit(__isset_bitfield, __WORKERCOUNT_ISSET_ID, value);
  }

  @Override
  public void setFieldValue(_Fields field, @org.apache.thrift.annotation.Nullable java.lang.Object value) {
    switch (field) {
    case WORKER_COUNT:
      if (value == null) {
        unsetWorkerCount();
      } else {
        setWorkerCount((java.lang.Integer)value);
      }
      break;

    }
  }

  @org.apache.thrift.annotation.Nullable
  @Override
  public java.lang.Object getFieldValue(_Fields field) {
    switch (field) {
    case WORKER_COUNT:
      return getWorkerCount();

    }
    throw new java.lang.IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
  @Override
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new java.lang.IllegalArgumentException();
    }

    switch (field) {
    case WORKER_COUNT:
      return isSetWorkerCount();
    }
    throw new java.lang.IllegalStateException();
  }

  @Override
  public boolean equals(java.lang.Object that) {
    if (that instanceof saveWork)
      return this.equals((saveWork)that);
    return false;
  }

  public boolean equals(saveWork that) {
    if (that == null)
      return false;
    if (this == that)
      return true;

    boolean this_present_workerCount = true;
    boolean that_present_workerCount = true;
    if (this_present_workerCount || that_present_workerCount) {
      if (!(this_present_workerCount && that_present_workerCount))
        return false;
      if (this.workerCount != that.workerCount)
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    int hashCode = 1;

    hashCode = hashCode * 8191 + workerCount;

    return hashCode;
  }

  @Override
  public int compareTo(saveWork other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;

    lastComparison = java.lang.Boolean.compare(isSetWorkerCount(), other.isSetWorkerCount());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetWorkerCount()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.workerCount, other.workerCount);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  @org.apache.thrift.annotation.Nullable
  @Override
  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  @Override
  public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
    scheme(iprot).read(iprot, this);
  }

  @Override
  public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    scheme(oprot).write(oprot, this);
  }

  @Override
  public java.lang.String toString() {
    java.lang.StringBuilder sb = new java.lang.StringBuilder("saveWork(");
    boolean first = true;

    sb.append("workerCount:");
    sb.append(this.workerCount);
    first = false;
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws org.apache.thrift.TException {
    // check for required fields
    // check for sub-struct validity
  }

  private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
    try {
      write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, java.lang.ClassNotFoundException {
    try {
      // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
      __isset_bitfield = 0;
      read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private static class saveWorkStandardSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    @Override
    public saveWorkStandardScheme getScheme() {
      return new saveWorkStandardScheme();
    }
  }

  private static class saveWorkStandardScheme extends org.apache.thrift.scheme.StandardScheme<saveWork> {

    @Override
    public void read(org.apache.thrift.protocol.TProtocol iprot, saveWork struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TField schemeField;
      iprot.readStructBegin();
      while (true)
      {
        schemeField = iprot.readFieldBegin();
        if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
          break;
        }
        switch (schemeField.id) {
          case 1: // WORKER_COUNT
            if (schemeField.type == org.apache.thrift.protocol.TType.I32) {
              struct.workerCount = iprot.readI32();
              struct.setWorkerCountIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          default:
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      struct.validate();
    }

    @Override
    public void write(org.apache.thrift.protocol.TProtocol oprot, saveWork struct) throws org.apache.thrift.TException {
      struct.validate();

      oprot.writeStructBegin(STRUCT_DESC);
      oprot.writeFieldBegin(WORKER_COUNT_FIELD_DESC);
      oprot.writeI32(struct.workerCount);
      oprot.writeFieldEnd();
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

  }

  private static class saveWorkTupleSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    @Override
    public saveWorkTupleScheme getScheme() {
      return new saveWorkTupleScheme();
    }
  }

  private static class saveWorkTupleScheme extends org.apache.thrift.scheme.TupleScheme<saveWork> {

    @Override
    public void write(org.apache.thrift.protocol.TProtocol prot, saveWork struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol oprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      java.util.BitSet optionals = new java.util.BitSet();
      if (struct.isSetWorkerCount()) {
        optionals.set(0);
      }
      oprot.writeBitSet(optionals, 1);
      if (struct.isSetWorkerCount()) {
        oprot.writeI32(struct.workerCount);
      }
    }

    @Override
    public void read(org.apache.thrift.protocol.TProtocol prot, saveWork struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol iprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      java.util.BitSet incoming = iprot.readBitSet(1);
      if (incoming.get(0)) {
        struct.workerCount = iprot.readI32();
        struct.setWorkerCountIsSet(true);
      }
    }
  }

  private static <S extends org.apache.thrift.scheme.IScheme> S scheme(org.apache.thrift.protocol.TProtocol proto) {
    return (org.apache.thrift.scheme.StandardScheme.class.equals(proto.getScheme()) ? STANDARD_SCHEME_FACTORY : TUPLE_SCHEME_FACTORY).getScheme();
  }
}

